package com.xlf.icousll

object InputData {
    fun readList(): Link<String> {
        var read: String
        do {
            read = readlnOrNull()!!
        } while (read.isBlank())
        // 将内容编译进入数组
        return Link(read.split(","))
    }

    /**
     * 对两个自定义链表进行判等操作
     */
    fun combinedCalculation(firstLink: Link<String>, secondLink: Link<String>): Boolean {
        // 判断两个链表的长度是否相等
        if (firstLink.size != secondLink.size) {
            return false
        }
        // 判断两个链表的元素是否相等
        var temp1 = firstLink.head.next
        var temp2 = secondLink.head.next
        while (temp1 != null && temp2 != null) {
            if (temp1.value != temp2.value) {
                return false
            }
            temp1 = temp1.next
            temp2 = temp2.next
        }
        return true
    }

    /**
     * 对两个自定义链表进行交操作，并且输出交后的 {x,x,x} 值
     */
    fun handOver(firstLink: Link<String>, secondLink: Link<String>): String {
        // 判断两个链表的长度是否相等
        if (firstLink.size != secondLink.size) {
            return "两个集合的长度不相等，无法进行交操作"
        }
        // 判断两个链表的元素是否相等
        var temp1 = firstLink.head.next
        var temp2 = secondLink.head.next
        var result = "{ "
        while (temp1 != null && temp2 != null) {
            if (temp1.value == temp2.value) {
                result += temp1.value + ","
            }
            temp1 = temp1.next
            temp2 = temp2.next
        }
        result = result.substring(0, result.length - 1)
        result += " }"
        return result
    }

    /**
     * 对两个自定义链表进行并操作，并且输出并后的 {x,x,x} 值
     */
    fun combine(firstLink: Link<String>, secondLink: Link<String>): String {
        // 判断两个链表的长度是否相等
        if (firstLink.size != secondLink.size) {
            return "两个集合的长度不相等，无法进行并操作"
        }
        // 判断两个链表的元素是否相等
        var temp1 = firstLink.head.next
        var temp2 = secondLink.head.next
        var result = "{ "
        while (temp1 != null && temp2 != null) {
            result += temp1.value + ","
            temp1 = temp1.next
            temp2 = temp2.next
        }
        result = result.substring(0, result.length - 1)
        result += " }"
        return result

    }

    /**
     * 对两个自定义链表进行差操作，并且输出差后的 {x,x,x} 值
     */
    fun difference(firstLink: Link<String>, secondLink: Link<String>): String {
        // 判断两个链表的长度是否相等
        if (firstLink.size != secondLink.size) {
            return "两个集合的长度不相等，无法进行差操作"
        }
        // 判断两个链表的元素是否相等
        var temp1 = firstLink.head.next
        var temp2 = secondLink.head.next
        var result = "{ "
        while (temp1 != null && temp2 != null) {
            if (temp1.value != temp2.value) {
                result += temp1.value + ","
            }
            temp1 = temp1.next
            temp2 = temp2.next
        }
        result = result.substring(0, result.length - 1)
        result += " }"
        return result
    }

    /**
     * 释放链表
     */
    fun freeLinkedList(link: Link<String>): Boolean {
        link.head.next = null
        link.size = 0
        return true
    }
}